<?php 
include 'constants.php'; 
include 'storage.php'; 
include 'apis.php'; 
include 'functions.php'; 

$pb_res=array();
/*------------Recceiving data from CRM postabck----------------*/
$pb_res['orderId'] = isset($_POST['order_id']) ? trim($_POST['order_id']) : "";
$pb_res['email'] = isset($_POST['email']) ? trim($_POST['email']) : ""; 
$pb_res['first_name'] = isset($_POST['first_name']) ? trim($_POST['first_name']) : ""; 
$pb_res['last_name'] = isset($_POST['last_name']) ? trim($_POST['last_name']) : ""; 
$pb_res['product_id_csv'] = isset($_POST['product_id']) ? trim($_POST['product_id']) : "";
$pb_res['phone'] = isset($_POST['phone']) ? trim($_POST['phone']) : "";
$pb_res['shipping_city'] = isset($_POST['shipping_city']) ? trim($_POST['shipping_city']) : "";
$pb_res['shipping_state_id'] = isset($_POST['shipping_state_id']) ? trim($_POST['shipping_state_id']) : "";
$pb_res['shipping_country'] = isset($_POST['shipping_country']) ? trim($_POST['shipping_country']) : "";
$pb_res['shipping_address'] = isset($_POST['shipping_address']) ? trim($_POST['shipping_address']) : "";
$pb_res['shipping_zip'] = isset($_POST['shipping_zip']) ? trim($_POST['shipping_zip']) : "";
$pb_res['order_status'] = isset($_POST['order_status']) ? trim($_POST['order_status']) : "";
$pb_res['order_date_time'] = isset($_POST['order_date_time']) ? date_format(date_create(trim($_POST['order_date_time'])), "Y-m-d H:i:s") : "";


/*------------having more fields----------------*/
$pb_res['full_name'] = $pb_res['first_name'].$pb_res['last_name'];

/*------------variables-------------*/
$insert_res = array();
$api_payload = array();
$raw_api_response = "";
$postback_type = "";
$update_res = "";
$condition_mismatch = false;
$notes = "";
$cus_msg = "";


/*------------conditions to check which API to fire---------------*/
if (in_array($pb_res['product_id_csv'], $dsf_initial_prd_ids) && $pb_res['order_status'] == '1') { //dsf initial & active

    $check_dsf = check_dsf_order_id($pb_res);
    if ($check_dsf==0) {
        $postback_type = "create_cutomer";
        $insert_res = insert_table_dsf($pb_res);
        $api_payload = preapare_profile_create_user($pb_res);
        $raw_api_response = create_user_dsf_api($api_payload);
        $update_res = update_table_dsf($postback_type, $raw_api_response, $pb_res['orderId']);

        $cus_msg = "It is DSF initial product [Approved]<br><br>";
    } else {
        $notes = "Duplicate DSF order found";
        $condition_mismatch = true;
    }

} else if (in_array($pb_res['product_id_csv'], $dsf_rebill_prd_ids)){ //dsf rebill & active/declined

    if ($pb_res['order_status'] == '1' || $pb_res['order_status'] == '0') {

        $check_dsf = check_dsf_order_id($pb_res);
        if ($check_dsf==0) {
            $postback_type = "rebill_customer";
            $insert_res = insert_table_dsf($pb_res);
            $api_payload = preapare_profile_rebill_user($pb_res);
            $raw_api_response = rebill_user_dsf_api($api_payload);
            $update_res = update_table_dsf($postback_type, $raw_api_response, $pb_res['orderId']);

            $cus_msg = "It is DSF active rebill";
        } else {
            $notes = "Duplicate DSF order found";
            $condition_mismatch = true;
        }
    } else { //error
        $notes = "Error: Invalid order status";
        $condition_mismatch = true;
    }

} else if (in_array($pb_res['product_id_csv'], $rsf_initial_prd_ids)  && $pb_res['order_status'] == '1') { //rsf initial & active

    $check_rsf = check_rsf_order_id($pb_res);
    if ($check_rsf==0) {
        $postback_type = "create_cutomer";
        $insert_res = insert_table_rsf($pb_res);
        $api_payload = preapare_profile_create_user($pb_res);
        $raw_api_response = create_user_rsf_api($api_payload);
        $update_res = update_table_rsf($postback_type, $raw_api_response, $pb_res['orderId']);

        $cus_msg = "It is RSF initial product";
    } else {
        $notes = "Duplicate RSF order found";
        $condition_mismatch = true;
    }
} else if(in_array($pb_res['product_id_csv'], $rsf_rebill_prd_ids)) { //rsf rebill & active/declined

    
    if ($pb_res['order_status'] == '1' || $pb_res['order_status'] == '0') {

        $check_rsf = check_rsf_order_id($pb_res);
        if ($check_rsf==0) {
            $postback_type = "rebill_customer";
            $insert_res = insert_table_rsf($pb_res);
            $api_payload = preapare_profile_rebill_user($pb_res);
            $raw_api_response = rebill_user_rsf_api($api_payload);
            $update_res = update_table_rsf($postback_type, $raw_api_response, $pb_res['orderId']);

            $cus_msg = "It is RSF active rebill";
        } else {
            $notes = "Duplicate RSF order found";
            $condition_mismatch = true;
        }
    } else {
        $notes = "Error: Invalid order status";
        $condition_mismatch = true;
    }

} else { //error
    $notes = "unknown condition";
    $condition_mismatch = true;
}

if ($condition_mismatch == true) {
    $pb_res['notes'] = $notes;
    $insert_res = insert_table_error($pb_res);
    $cus_msg = "Error: Condition mismatch";
}

?>